<?php
/************************************************************/
/* $Id: mse.php,v 1.17 2004/09/09 08:50:28 engine Exp engine $  */
/* Copyright (c) Ohad Aloni 1990-2004. All rights reserved. */
/* Released under http://www.engine.com/license.txt (BSD) */
/************************************************************/
// msdb Smarty Editor
//
// conventions:
//
// mseTable - the name of the table.
// 		$mseTable.tpl - one row. // search, insert, Update, etc.
//		$mseTable.Rows.tpl
//
// mseIdName - the name of the id field, for updates and deletes.
//
// mseDo - Injsert, Update or Delete
// 		when mseDo is not set:
//			if $mseIdName is set, this record is shown, otherwise,
//			a search is performed, or a default sql is picked up by the code,
//			and the rows are shown.

/************************************************************/
global $smarty;
if ( ! isset($smarty) )
        return;
/************************************************************/

function mseMain()
{
        if ( ! isset($_REQUEST['mseTable'] ) ) {
                msdbMsg("mseTable not set");
                return;
        }
        $mseTable = $_REQUEST['mseTable'] ;

        if ( ! isset($_REQUEST['mseIdName'] ) ) {
                msdbMsg("mseIdName not set");
                return;
        }
        $mseIdName = $_REQUEST['mseIdName'] ;

        if ( ! mseInit($mseTable, $mseIdName) )
                return;

        if ( isset($_REQUEST['mseDo']) ) {
                mseDo($_REQUEST['mseDo'], $mseTable, $mseIdName);
                return;
        }

        $cnt = msDbRowNum($mseTable);
        if ( $cnt == 1 ) {
                $mseIdValue = msDbGetString("select max($mseIdName) from $mseTable");
                mseShowRecord($mseTable, $mseIdName, $mseIdValue);
                return;
        }
        if ( $cnt == 0 ) {
                mseShowRecord($mseTable, $mseIdName, null);
                return;
        }

        if ( isset($_REQUEST[$mseIdName]) && $_REQUEST[$mseIdName] != '' ) {
                $mseIdValue = $_REQUEST[$mseIdName];
                mseShowRecord($mseTable, $mseIdName, $mseIdValue);
                return;
        }

        // search and/or show rows

        mseShowRows($mseTable, $mseIdName);
}

/************************************************************/

// lines per page in multi-row display

function mseLpp()
{
        if ( isset($_REQUEST['mseLpp']) )
                return($_REQUEST['mseLpp']);
        /*	return(3);	*/
        return(40);
}

/******************************/

function mseDefaultSql($t, $idn)
{
        $lpp = mseLpp();

        $cnt = msDbGetString("select count(*) from $t");
        if ( $cnt <= $lpp )
                return("select * from $t");

        return("select * from $t order by $idn desc limit $lpp");
}

/******************************/

function mseVerifyTemplates($mseTable, $mseIdName)
{
        global $smarty;

        if ( ! isset($smarty->template_dir) ) {
                msdbMsg("smarty template dir not set");
                return(false);
        }

        $recordFile = $smarty->template_dir."/$mseTable.row.tpl";
        if ( ! is_readable($recordFile) ) {
                msdbMsg("Can not read from file: $recordFile");
                msePrintDefaultTemplate($mseTable, $mseIdName, false);
                return(false);
        }

        $rowsFile = $smarty->template_dir."/$mseTable.rows.tpl";
        if ( ! is_readable($rowsFile) ) {
                msdbMsg("Can not read from file: $rowsFile");
                msePrintDefaultTemplate($mseTable, $mseIdName, true);
                return(false);
        }
        return(true);
}

/******************************/

function mseEchoParsedFile($file, $args)
{
        if ( ! ($str = file_get_contents($file)) ) {
                msdbMsg("$file: Can not read");
                return;
        }
        $out = msdbStrParse($str, $args);

        $htOut = htmlspecialchars($out);

        echo $htOut;
        /*	echo $out; // for lynx -source	*/
}

/******************************/
// each file has 5 sections. 1 3 5 are not iterative, 2 and 4 are.

function msePrintDefaultTemplate($mseTable, $mseIdName, $isRows)
{
        if ( ! ( $msdbHome = msdbMyHome()) ) {
                msdbMsg("msePrintDefaultRecordTemplate: msdbConfig[myHome'] not set");
                return;
        }

        $mseArgs = array(
                                'mseTable' => $mseTable,
                                'mseIdName' => $mseIdName,
                        );

        $ext = $isRows ? "rows" : "row" ;

        echo "<BR><HR><BR><PRE>\n";
        mseEchoParsedFile("$msdbHome/include/mse.$ext.1.h", $mseArgs);

        $colNames = msDbColNames($mseTable);

        foreach ( array(2, 4) as $i ) {
                if ( $i == 4 )
                        mseEchoParsedFile("$msdbHome/include/mse.$ext.3.h", $mseArgs);
                foreach ( $colNames as $colName ) {
                        if ( $colName == $mseIdName )
                                continue; // id handled by static sections.

                        $mseArgs = array(
                                                'mseTable' => $mseTable,
                                                'mseIdName' => $mseIdName,
                                                'mseFname' => $colName,
                                        );

                        mseEchoParsedFile("$msdbHome/include/mse.$ext.$i.h", $mseArgs);
                }
        }

        mseEchoParsedFile("$msdbHome/include/mse.$ext.5.h", $mseArgs);
        echo "</PRE><BR><HR><BR>\n";
}

/******************************/

function mseInit($mseTable, $mseIdName)
{
        global $smarty;

        if ( ! mseVerifyTemplates($mseTable, $mseIdName) )
                return(false);

        msuRegisterFunctions();
        $smarty->assign(array(
                                                'mseTable' => $mseTable,
                                                'mseIdName' => $mseIdName,
                                                'mseLpp' => mseLpp(),
                                                'mseYesNo' => array(0 => 'No', 1 => 'Yes'),
                                                'mseColNames' => msDbColNames($mseTable),
                                                'mseColors' => array(
                                                                                        'title' => 'CCCCCC',
                                                                                        'bg' => 'DDDDDD',
                                                                                        'oddBg' => 'DDDDDD',
                                                                                        'evenBg' => 'EEEEEE', // when the template individualy displays the lines
                                                                                        'oddEvenBg' => array('DDDDDD', 'EEEEEE',), // for {cycle ...}
                                                                                        ),
                                                'mseDbOps' => array(
                                                                                        '=' => '=',
                                                                                        '>' => '>',
                                                                                        '<' => '<',
                                                                                        '>=' => '>=',
                                                                                        '<=' => '<=',
                                                                                        '!=' => '!=',
                                                                                        'like' => 'like',
                                                                                ),
                                        ));
        return(true);
}

/************************************************************/

function mseNew($mseTable, $mseIdName)
{
        $sql = msDbInsertSql($mseTable, $_REQUEST, $mseIdName);
        $affected = msDbSql($sql);
        $mseIdValue = $affected == 1 ? msDbInsertId() : null ;
        msdbMsg($affected == 1 ? "New $mseTable Record Created" : "Record Not Created");
        mseShowRecord($mseTable, $mseIdName, $mseIdValue);
}

/************************************************************/

function mseUpdate($mseTable, $mseIdName)
{
        if ( ! isset($_REQUEST[$mseIdName]) ) {
                msdbMsg("mseUpdate: $mseIdName not set");
                return;
        }

        $mseIdValue = $_REQUEST[$mseIdName] ;
        $sql = msDbUpdateSql($mseTable, $_REQUEST, "where $mseIdName = '$mseIdValue'");
        $affected = msDbSql($sql);
        msdbMsg($affected == 1 ? "Updated $mseTable where $mseIdName = $mseIdValue" : "Not Updated");
        mseShowRecord($mseTable, $mseIdName, $mseIdValue);
}

/************************************************************/

function mseDelete($mseTable, $mseIdName)
{
        if ( ! isset($_REQUEST[$mseIdName]) ) {
                msdbMsg("mseDelete: $mseIdName not set");
                return;
        }

        $mseIdValue = $_REQUEST[$mseIdName] ;
        $sql = "delete from $mseTable where $mseIdName = '$mseIdValue'";
        $affected = msDbSql($sql);
        msdbMsg($affected == 1 ? "Deleted $mseTable where $mseIdName = $mseIdValue" : "Not Deleted");
        mseShowRows($mseTable, $mseIdName);
}

/************************************************************/

// changing button labes requires some more '||' here

function mseDo($what, $mseTable, $mseIdName)
{
        global $smarty;

        if ( $what == 'Update' || $what == 'Change' ) {
                mseUpdate($mseTable, $mseIdName);
                return;
        }

        if ( $what == 'New' || $what == 'Insert' ) {
                mseNew($mseTable, $mseIdName);
                return;
        }

        if ( $what =='Delete' || $what == 'Discard' ) {
                mseDelete($mseTable, $mseIdName);
                return;

        }

        // either Search, or default
        mseShowRows($mseTable, $mseIdName);
}

/************************************************************/

function mseShowRecord($mseTable, $mseIdName, $mseIdValue)
{
        global $smarty;

        if ( $mseIdValue )
                $data = msDbGet1Assoc("select * from $mseTable where $mseIdName = '$mseIdValue'");
        else
                $data = $_REQUEST; // pass back whatever came in, to be reused as the current row.

        $msuReturnCode = $data ? 1 : 0 ;
        $smarty->assign(array(
                                                'mseTable' => $mseTable,
                                                'mseIdName' => $mseIdName,
                                                'mseRow' => $data,
                                                'msuReturnCode' => $msuReturnCode,
                                ));

        $smarty->display("$mseTable.row.tpl");
}

/************************************************************/

function mseOrderBy($mseTable, $mseIdName)
{
        if ( isset($_REQUEST['mseOrderBy'] ) ) {
                $mseOrderBy = $_REQUEST['mseOrderBy'];
                $mseAscDesc = $_REQUEST['mseAscDesc'];
        } else {
                $mseOrderBy = $mseIdName;
                $mseAscDesc = 'desc';
        }


        if ( ! isset($_REQUEST['mseSortBy']) )
                return(array($mseOrderBy, $mseAscDesc));

        $mseSortBy = $_REQUEST['mseSortBy'];

        if ( $mseSortBy == $mseOrderBy ) {
                $mseAscDesc = ( $mseAscDesc == 'asc' ) ? 'desc' : 'asc' ;
                return(array($mseOrderBy, $mseAscDesc));
        }
        $mseOrderBy = $mseSortBy;
        $mseAscDesc = 'asc';
        return(array($mseOrderBy, $mseAscDesc));
}

/************************************************************/

function oldMseShowRows($mseTable, $mseIdName)
{
        global $smarty;

        $sql = mseDefaultSql($mseTable, $mseIdName);

        $data = msDbGetAssoc($sql);

        /*	if ( ! is_array($data) )	*/
                /*	return;	*/

        $smarty->assign(array(
                                                'mseQuery' => $sql,
                                                'mseRows' => $data,
                                                'msuReturnCode' => 1,
                                ));
        $smarty->display("$mseTable.rows.tpl");
}

/******************************/

function mseCurrentPage()
{
        if ( isset($_REQUEST['mseCurrentPage']) )
                return($_REQUEST['mseCurrentPage']);
        return(1); // the first page
}

/******************************/

function mseLimit($mseCurrentPage, $mseRowNum, $lpp)
{
        if ( $mseRowNum <= $lpp )
                return("");
        $limitStart = ($mseCurrentPage - 1) * $lpp ;
        return("limit $limitStart, $lpp");
}

/******************************/

function mseQueryCondition()
{
        if ( isset($_REQUEST['mseDo']) && $_REQUEST['mseDo'] == 'Search' ) {
                $ret = msDbQueryBuild($mseTable);
                if ( ! $ret ) {
                        mseShowRecord($mseTable, $mseIdName, null);
                        return(false);;
                }
                return($ret);
        }

        if ( isset($_REQUEST['mseQueryCondition']) ) {
                $rawCond = rawurldecode($_REQUEST['mseQueryCondition']); // could still be ''
                $ret = ereg_replace("\\\\", "", $rawCond);
                return($ret);
        }
        return("");
}

/******************************/

function mseShowRows($mseTable, $mseIdName)
{
        global $smarty;

        $lpp = mseLpp();

        if ( ! ($mseQueryCondition = mseQueryCondition()) === false ) // false, not ''
                return;

        $w = ( $mseQueryCondition ) ? "where $mseQueryCondition" : "" ;
        $mseRowNum = msDbGetString("select count(*) from $mseTable $w");
        if ( $mseRowNum == 0 ) {
                msdbMsg("No records found $mseCond");
                mseShowRecord($mseTable, $mseIdName, null);
                return;
        }

        $mseCurrentPage = mseCurrentPage();
        $mseLimit = mseLimit($mseCurrentPage, $mseRowNum, $lpp);
        list($ob, $ad) = mseOrderBy($mseTable, $mseIdName);

        $q = "select * from $mseTable $w order by $ob $ad $mseLimit";

        $rows = msDbGetAssoc($q);

        if ( $mseRowNum == 1 ) {
                $mseIdValue = $rows[0][$mseIdName];
                mseShowRecord($mseTable, $mseIdName, $mseIdValue);
                return;
        }

        $smarty->assign(array(
                'mseTable' => $mseTable,
                'mseIdName' => $mseIdName,
                'mseRows' => $rows,
                'msuReturnCode' => (is_array($rows) ? 1 : 0),
                'mseQuery' => $q,
                'mseQueryCondition' => rawurlencode($mseQueryCondition),
                'mseOrderBy' => $ob,
                'mseAscDesc' => $ad,
        ));
        $smarty->display("$mseTable.rows.tpl");

        mseShowNav($mseTable, $mseIdName, $mseCurrentPage, $mseRowNum);
}

/************************************************************/

function mseShowNav($mseTable, $mseIdName, $mseCurrentPage, $mseRowNum)
{
        global $smarty;

        $lpp = mseLpp();

        $mh = msdbMyHome();
        $tplDir = $smarty->template_dir;

        if ( is_readable("$tplDir/$mseTable.mseNav.tpl") )
                $navTpl = "$tplDir/$mseTable.mseNav.tpl" ;
        else if ( is_readable("$tplDir/mseNav.tpl") )
                $navTpl = "$tplDir/mseNav.tpl" ;
        else if ( is_readable("$mh/include/mseNav.tpl") )
                $navTpl = "$mh/include/mseNav.tpl" ;
        else {
                msdbMsg("mseShowNav: Can not find Nav Template");
                return;
        }

        $msePageList = msePageList($mseTable, $mseIdName, $mseCurrentPage, $mseRowNum);

        if ( count($msePageList) == 0 )
                $mseNpages = 1;
        else
                $mseNpages = $msePageList[count($msePageList)-1];

        $smarty->assign(array(
                        'msePageList' => $msePageList,
                        'mseNpages' => $mseNpages,
                        'mseRowNum' => $mseRowNum,
                        'mseCurrentPage' => $mseCurrentPage,
                        'mseLpp' => $lpp,
                ));
        $smarty->display($navTpl);
}

/************************************************************/

function msePageList($mseTable, $mseIdName, $mseCurrentPage, $mseRowNum)
{
        $lpp = mseLpp();

        $mod = $mseRowNum % $lpp ;
        $nPages = ($mseRowNum - $mod) / $lpp ;
        if ( $mod > 0 )
                $nPages++;
        if ( $nPages <= 1 )
                return(array());

        $ret = array();

        for($i=1;$i <= $nPages;$i++) {
                if ( $i == 1 || $i == $nPages || abs($i-$currentPage) < 5 ) {
                        $ret[] = $i;
                        continue;
                }
                if ( $i % 10 != 0 )
                        continue;
                if ( $i % 50 == 0 ) {
                        $ret[] = $i;
                        continue;
                }
                if ( abs($i-$currentPage) > 50 )
                        continue;
                // mod 10 < 50
                $ret[] = $i;
        }

        return($ret);
}

/************************************************************/
?>
