<?php
/************************************************************/
/* $Id: msu.php,v 1.7 2004/09/09 08:50:29 engine Exp engine $  */
/* Copyright (c) Ohad Aloni 1990-2004. All rights reserved. */
/* Released under http://www.engine.com/license.txt (BSD) */
/************************************************************/
// msdb Smarty Utilities
/************************************************************/
global $smarty;
if ( ! isset($smarty) )
	return;
/************************************************************/

function msuRegisterFunctions()
{
	global $smarty;

	$msuFuncs = array(
					'msuDbGet1Assoc',
					'msuDbGetAssoc',
					'msuDbGetStrings',
					'msuDbGetString',
				);

	foreach ( $msuFuncs as $func )
		$smarty->register_function($func, $func, false);

	$msuModifiers = array(
				'msdbPhpDate',
				);

	foreach ( $msuModifiers as $m )
		$smarty->register_modifier($m, $m);

}

/************************************************************/

// the use of this function by the ones below imply the calling naming conventions
// and return value conventions:
// normally, the name passed as a db query is 'q',
// the name of the return value is decided by the calling function.
// msuReturnCode is a special success/failure to enable { if $msuReturnCode == 0 }
// in the templates

function msuAssign($name, $value, $retCode)
{
	global $smarty;

	$smarty->assign(array(
					$name => $value,
					'msuReturnCode' => $retCode ? 1 : 0,
			));
}

/************************************************************/

function msuDbGet1Assoc($args)
{
	$a = msDbGet1Assoc($args['q']);
	msuAssign('row', $a, is_array($a));
}

/******************************/

function msuDbGetAssoc($args)
{
	$a = msDbGetAssoc($args['q']);
	msuAssign('rows', $a, is_array($a));
}

/******************************/

function msuDbGetStrings($args)
{
	$stringsName = $args['stringsName'];
	$s = msDbGetStrings($args['q']);
	msuAssign($strName, $a, is_array($a));
}


/******************************/

function msuDbGetString($args)
{
	$stringName = $args['stringName'];
	$s = msDbGetString($args['q']);

	msuAssign($stringName, $a, $a !== null);
}

/************************************************************/
// e.g. in the template for the table containing userId as a refrence to the user table
// select the userId by their name
// {msuDbHtmlOptions optNames=userNames optValues=userIds q="select name,id from user where bla = blu"}
// {html_options values=$userIds output=$userNames selected=$row.userId name=userId}

function msuDbHtmlOptions($args)
{
	global $smarty;

	$optNames = $args['optNames'];
	$optValues = $args['optValues'];
	$q = $args["q"];

	$a = msDbGetAssoc($q);

	$names=array();
	$values=array();

	$keys = array_keys($a[0]);

	foreach ( $a as $opt ) {
		$names[] = $opt[$key[0]];
		$values[] = $opt[$key[1]];
	}

	$smarty->assign(array(
		$optNames => $names,
		$optValues => $values,
		));
}

/************************************************************/
?>
